diff -urN asterisk-1.2.9/channels/chan_iax2.c asterisk-1.2.9-work/channels/chan_iax2.c
--- asterisk-1.2.9/channels/chan_iax2.c	2006-06-06 03:53:16.000000000 +0800
+++ asterisk-1.2.9-work/channels/chan_iax2.c	2006-06-14 08:48:38.000000000 +0800
@@ -6779,6 +6779,11 @@
 				break;
 			case IAX_COMMAND_TXACC:
 				if (iaxs[fr->callno]->transferring == TRANSFER_BEGIN) {
+					/* Set the transfer address to this message's origin (we may have sent multiple TXCNTs to different addresses) */
+					if (inaddrcmp(&sin, &iaxs[fr->callno]->transfer)) {
+						iaxs[fr->callno]->transfer.sin_addr.s_addr = sin.sin_addr.s_addr;
+						iaxs[fr->callno]->transfer.sin_port = sin.sin_port;
+					}
 					/* Ack the packet with the given timestamp */
 					ast_mutex_lock(&iaxq.lock);
 					for (cur = iaxq.head; cur ; cur = cur->next) {
@@ -7494,8 +7499,17 @@
 				try_transfer(iaxs[fr->callno], &ies);
 				break;
 			case IAX_COMMAND_TXCNT:
-				if (iaxs[fr->callno]->transferring)
+				if (iaxs[fr->callno]->transferring) {
+					/* Change transfer address to where this packet came from (if it doesn't match the one given by TXREQ) */
+					/* And resend a TXCNT to this new address, if we haven't already received a TXACC */ 
+					if (inaddrcmp(&sin, &iaxs[fr->callno]->transfer)) {
+						iaxs[fr->callno]->transfer.sin_addr.s_addr = sin.sin_addr.s_addr;
+						iaxs[fr->callno]->transfer.sin_port = sin.sin_port;
+						if (iaxs[fr->callno]->transferring == TRANSFER_BEGIN) 
+							try_transfer(iaxs[fr->callno], &ies);
+					}
 					send_command_transfer(iaxs[fr->callno], AST_FRAME_IAX, IAX_COMMAND_TXACC, 0, NULL, 0);
+				}
 				break;
 			case IAX_COMMAND_TXREL:
 				/* Send ack immediately, rather than waiting until we've changed addresses */
